% -------------------------------------------------------
%05/08/2015  ## this is a program for selection of best gene pair (Max=3)
% to construct the regulatory network. Here Cuckoo search algorithm is used
% for minimization of the error function that is created after Recurremt Neural
% network between those 3 genes. Cuckoo optimization is used for to search
% in 30 dimensional space tops select the best gene list. 
% BA is used to optimize the parameters of the Recurrent Neural Network  
% -------------------------------------------------------
function [bestsol,fval]=cuckoo_search_old(Ngen)
% Here Ngen is the max number of function evaluations
clc
clear all;
if nargin<1, Ngen=10; end
% d-dimensions (any dimension)
d=3;
% Number of nests (or different solutions)
n=10;
% Discovery rate of alien eggs/solutions
pa=0.25;

%select target gene gn
gn=1;

%initialization
j=1;
for i=1:10
    nest(i,:)=[j j+1 j+2];
    j=j+3;
end;
nest;
for i=1:10
    fbest(i)=fobj(nest(i,:),gn);
    if (fbest(i) < 1*10^(-8))
            break;
       else 
           continue;
    end;
end;
fbest;
if (min(fbest) > 1*10^(-8))
for j=1:Ngen
    Kbest=get_best_nest(fbest)
    
    % Choose a random nest (avoid the current best)
    k=choose_a_nest(n,Kbest);
    bestnest=nest(Kbest,:);
    
    % Generate a new solution (but keep the current best)
    s=get_a_cuckoo(nest(k,:),bestnest)
    % Evaluate this solution
    fnew=fobj(s,gn);
    if fnew<=fbest(k),
    fbest(k)=fnew;
    nest(k,:)=s;
    end;
    if (fbest(k) < 1*10^(-8))
            break;
       else 
           continue;
    end;
    if rand<pa,
    k=get_max_nest(fbest);
    s=emptyit(nest(k,:));
    nest(k,:)=s;
    fbest(k)=fobj(s,gn);
    if (fbest(k) < 1*10^(-8))
            break;
       else 
           continue;
    end;
    end;
end;
end;
%% Post-optimization processing
%% Find the best and display
[fval,I]=min(fbest);
fval
bestsol=nest(I,:)

